package com.yone.servlet;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Iterator;

import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.yone.InvIdException;
import com.yone.Product;
import com.yone.ProductFinder;

/**
 * @version 	1.0
 * @author
 */
public class ProductPageController extends HttpServlet implements Servlet {

	ServletContext ctx = null;

	/**
	* @see javax.servlet.http.HttpServlet#void (javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	*/
	public void doGet(HttpServletRequest req, HttpServletResponse resp)
		throws ServletException, IOException {

	}

	/**
	* @see javax.servlet.http.HttpServlet#void (javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	*/
	public void doPost(HttpServletRequest req, HttpServletResponse resp)
		throws ServletException, IOException {
			HttpSession s = req.getSession(true);
			ProductPageMessage m = (ProductPageMessage)s.getAttribute("message");
			if(m == null) {
				m = new ProductPageMessage();
				s.setAttribute("message",m);
			}
			try {
				Product p = ProductFinder.find(req.getParameter("productid"));
				System.out.println("id="+p.getId());
				s.setAttribute("product",p);
				m.setMessage("");
				s.setAttribute("message",m);
				RequestDispatcher rd =
					ctx.getRequestDispatcher("/plain/ProductDisp.jsp");
				rd.forward(req, resp);
			} catch(InvIdException e) {
				m.setMessage("IDႢ܂Bē͂ĂB");
				s.setAttribute("message",m);
				RequestDispatcher rd =
					ctx.getRequestDispatcher("/plain/ProductInput.jsp");
				rd.forward(req, resp);
			}
	}

	/* ( Javadoc)
	 * @see javax.servlet.Servlet#init(javax.servlet.ServletConfig)
	 */
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
		synchronized(this) {
		   if(ctx == null) {
			  ctx = config.getServletContext();
		   }
		}
	}

}
