package strutsjsfweb.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.yone.Product;
import com.yone.ProductFinder;

import strutsjsfweb.forms.ProductFormBean;

/**
 * @version 	1.0
 * @author
 */
public class ProductAction extends Action {

	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {

		ActionErrors errors = new ActionErrors();
		ActionForward forward = new ActionForward();
		// return value
		ProductFormBean productFormBean = (ProductFormBean) form;

		try {
			Product p = ProductFinder.find(productFormBean.getId());
			productFormBean.setName(p.getName());
			productFormBean.setPrice(p.getPrice());
		} catch (Exception e) {
			errors.add("name", new ActionError("invalid.id"));
		}

		if (!errors.isEmpty()) {
			saveErrors(request, errors);
			forward = mapping.findForward("failure");
		} else {
			forward = mapping.findForward("success");
		}

		// Finish with
		return (forward);

	}
}
